8cf838
From bb0e7fabcaed9a7e71e30f05e638e9f243cdb13e Mon Sep 17 00:00:00 2001
8cf838
From: =?UTF-8?q?P=C3=A1draig=20Brady?= <P@draigBrady.com>
8cf838
Date: Mon, 25 Jan 2021 14:12:48 +0000
8cf838
Subject: [PATCH] split: fix --number=K/N to output correct part of file
8cf838
8cf838
This functionality regressed with the adjustments
8cf838
in commit v8.25-4-g62e7af032
8cf838
8cf838
* src/split.c (bytes_chunk_extract): Account for already read data
8cf838
when seeking into the file.
8cf838
* tests/split/b-chunk.sh: Use the hidden ---io-blksize option,
8cf838
to test this functionality.
8cf838
Fixes https://bugs.gnu.org/46048
8cf838
8cf838
Upstream-commit: bb21daa125aeb4e32546309d370918ca47e612db
8cf838
Signed-off-by: Kamil Dudka <kdudka@redhat.com>
8cf838
---
8cf838
 src/split.c            |  2 +-
8cf838
 tests/split/b-chunk.sh | 45 ++++++++++++++++++++++++------------------
8cf838
 2 files changed, 27 insertions(+), 20 deletions(-)
8cf838
8cf838
diff --git a/src/split.c b/src/split.c
8cf838
index 09e610b..19248f6 100644
8cf838
--- a/src/split.c
8cf838
+++ b/src/split.c
8cf838
@@ -1001,7 +1001,7 @@ bytes_chunk_extract (uintmax_t k, uintmax_t n, char *buf, size_t bufsize,
8cf838
     }
8cf838
   else
8cf838
     {
8cf838
-      if (lseek (STDIN_FILENO, start, SEEK_CUR) < 0)
8cf838
+      if (lseek (STDIN_FILENO, start - initial_read, SEEK_CUR) < 0)
8cf838
         die (EXIT_FAILURE, errno, "%s", quotef (infile));
8cf838
       initial_read = SIZE_MAX;
8cf838
     }
8cf838
diff --git a/tests/split/b-chunk.sh b/tests/split/b-chunk.sh
8cf838
index 864ce55..39a6799 100755
8cf838
--- a/tests/split/b-chunk.sh
8cf838
+++ b/tests/split/b-chunk.sh
8cf838
@@ -35,32 +35,39 @@ split -e -n 10 /dev/null || fail=1
8cf838
 returns_ 1 stat x?? 2>/dev/null || fail=1
8cf838
 
8cf838
 printf '1\n2\n3\n4\n5\n' > input || framework_failure_
8cf838
+printf '1\n2' > exp-1 || framework_failure_
8cf838
+printf '\n3\n' > exp-2 || framework_failure_
8cf838
+printf '4\n5\n' > exp-3 || framework_failure_
8cf838
 
8cf838
 for file in input /proc/version /sys/kernel/profiling; do
8cf838
   test -f $file || continue
8cf838
 
8cf838
-  split -n 3 $file > out || fail=1
8cf838
-  split -n 1/3 $file > b1 || fail=1
8cf838
-  split -n 2/3 $file > b2 || fail=1
8cf838
-  split -n 3/3 $file > b3 || fail=1
8cf838
+  for blksize in 1 2 4096; do
8cf838
+    if ! test "$file" = 'input'; then
8cf838
+      # For /proc like files we must be able to read all
8cf838
+      # into the internal buffer to be able to determine size.
8cf838
+      test "$blksize" = 4096 || continue
8cf838
+    fi
8cf838
 
8cf838
-  case $file in
8cf838
-    input)
8cf838
-      printf '1\n2' > exp-1
8cf838
-      printf '\n3\n' > exp-2
8cf838
-      printf '4\n5\n' > exp-3
8cf838
+    split -n 3 ---io-blksize=$blksize $file > out || fail=1
8cf838
+    split -n 1/3 ---io-blksize=$blksize $file > b1 || fail=1
8cf838
+    split -n 2/3 ---io-blksize=$blksize $file > b2 || fail=1
8cf838
+    split -n 3/3 ---io-blksize=$blksize $file > b3 || fail=1
8cf838
 
8cf838
-      compare exp-1 xaa || fail=1
8cf838
-      compare exp-2 xab || fail=1
8cf838
-      compare exp-3 xac || fail=1
8cf838
-      ;;
8cf838
-  esac
8cf838
+    case $file in
8cf838
+      input)
8cf838
+        compare exp-1 xaa || fail=1
8cf838
+        compare exp-2 xab || fail=1
8cf838
+        compare exp-3 xac || fail=1
8cf838
+        ;;
8cf838
+    esac
8cf838
 
8cf838
-  compare xaa b1 || fail=1
8cf838
-  compare xab b2 || fail=1
8cf838
-  compare xac b3 || fail=1
8cf838
-  cat xaa xab xac | compare - $file || fail=1
8cf838
-  test -f xad && fail=1
8cf838
+    compare xaa b1 || fail=1
8cf838
+    compare xab b2 || fail=1
8cf838
+    compare xac b3 || fail=1
8cf838
+    cat xaa xab xac | compare - $file || fail=1
8cf838
+    test -f xad && fail=1
8cf838
+  done
8cf838
 done
8cf838
 
8cf838
 Exit $fail
8cf838
-- 
8cf838
2.26.2
8cf838